#!/bin/sh

BUDDY_FILE=/var/log/buddyinfo.csv
TIME="`date +%s`"
# Get the uptime in seconds | remove idle time | remove decimal
UPTIME=`cat /proc/uptime | cut -d ' ' -f 1 | cut -d '.' -f 1`
BUDDYINFO="$TIME;$UPTIME;"
# Add info from /proc/buddyinfo | remove all additional spaces | cut the leading text away | remove trailing space | replace spaces by semicolon
BUDDYINFO="$BUDDYINFO`cat /proc/buddyinfo | tr -s ' ' | cut -b 21- | sed 's/[ \t]*$//' | sed 's/ /;/g'`"

if ! [ -f "$BUDDY_FILE" ]
then
	echo "# UTCTimestamp;Uptime[s];2^0;2^1;2^2;2^3;2^4;2^5;2^6;2^7;2^8;2^9;2^10" >> "$BUDDY_FILE"
fi

echo "$BUDDYINFO" >> "$BUDDY_FILE"

exit 0