/*
 * ##################################################### Start DataLoggerPage #####################################################
 */
function DataLoggerPage() {
  this.dataLoggerArchiveEntries = undefined;
  this.dataLoggerArchiveEntriesUpdated = false;
  this.dataLoggerArchiveEntriesHash = undefined;

  if (!(this instanceof DataLoggerPage)) {
    return new DataLoggerPage();
  }
  PageTemplate.call(this);
  var thisClass = this;

  this.prepare = function() {
    if (!thisClass.contentSection) {
      thisClass.contentSection = document.createElement('div');
      var header = document.createElement('h3');
      header.setAttribute('class', 'h3');
      header.appendChild(document.createTextNode(i18n.translate('data_logger')));
      thisClass.contentSection.appendChild(header);
      thisClass.contentSection.appendChild(document.createTextNode(i18n.translate('data_logger_configuration_note')));
      thisClass.contentSection.appendChild(document.createElement('br'));
      thisClass.contentSection.appendChild(document.createElement('br'));
      thisClass.contentSection.appendChild(document.createTextNode(i18n.translate('sd_card_status') + ': '));
      var sdState = document.createTextNode('');
      thisClass.contentSection.appendChild(sdState);

      thisClass.contentSection.appendChild(document.createElement('br'));
      thisClass.contentSection.appendChild(document.createElement('br'));

      var divSpinnerWaitForData = document.createElement('div');
      divSpinnerWaitForData.setAttribute('class', 'spinner');
      divSpinnerWaitForData.setAttribute('id', 'WaitForData');
      thisClass.contentSection.appendChild(divSpinnerWaitForData);

      var archiveHeader = document.createElement('h3');
      archiveHeader.appendChild(document.createTextNode(i18n.translate('content')));
      archiveHeader.setAttribute('id', 'ArchiveHeader');
      archiveHeader.setAttribute('hidden', '');
      thisClass.contentSection.appendChild(archiveHeader);

      var dataLoggerArchiveEntriesList = document.createElement('div');
      dataLoggerArchiveEntriesList.setAttribute('container', '');
      dataLoggerArchiveEntriesList.setAttribute('id', 'DataLoggerArchiveEntries');
      thisClass.contentSection.appendChild(dataLoggerArchiveEntriesList);
      thisClass.contentSection.appendChild(document.createElement('br'));

      thisClass.dataBindings.push(function() {
        if (thisClass.dataLoggerArchiveEntriesUpdated === undefined || thisClass.dataLoggerArchiveEntriesUpdated) {
          thisClass.dataLoggerArchiveEntriesUpdated = false;
          var newArchiveEntries = document.createElement('div');
          newArchiveEntries.setAttribute('container', '');
          newArchiveEntries.setAttribute('id', 'DataLoggerArchiveEntries');
          if (thisClass.dataLoggerArchiveEntries) {
            thisClass.addArchiveColumns(newArchiveEntries);
            document.getElementById('WaitForData').setAttribute('hidden', '');
            document.getElementById('ArchiveHeader').removeAttribute('hidden');
          } else {
            document.getElementById('WaitForData').removeAttribute('hidden');
            document.getElementById('ArchiveHeader').setAttribute('hidden', '');
          }
          var oldNode = document.getElementById('DataLoggerArchiveEntries');
          var parent = oldNode.parentNode;
          parent.replaceChild(newArchiveEntries, oldNode);
        }
        if (mainSite.deviceInfo.SdCardPresent) {
          sdState.nodeValue = i18n.translate('sd_card_status_active').replace(/SDCARDUSAGE|SDCARDSIZE/gi,
              function(subst) {
                switch (subst) {
                  case 'SDCARDUSAGE':
                    return mainSite.deviceInfo.SdCardUsage;
                  case 'SDCARDSIZE':
                    return mainSite.deviceInfo.SdCardSize;
                }
              }) + ' ';
          if (thisClass.dataLoggerArchiveEntries === undefined) {
            document.getElementById('WaitForData').removeAttribute('hidden');
          }
        } else {
          sdState.nodeValue = i18n.translate("sd_card_status_not_present");
          document.getElementById('ArchiveHeader').setAttribute('hidden', '');
        }
      });
    }
    mainSite.main.appendChild(thisClass.contentSection);
    thisClass.requestData();
    thisClass.update();
    thisClass.setFocus();
  }

  this.addArchiveColumns = function(parent) {
    if (!thisClass.dataLoggerArchiveEntries || !Array.isArray(thisClass.dataLoggerArchiveEntries.years)) return;

    for (const year_entry of thisClass.dataLoggerArchiveEntries.years) {
      var year = document.createElement('div');
      year.setAttribute('row', '');
      year.setAttribute('id', 'year'+year_entry.year);
      var yearHeader = document.createElement('div');
      yearHeader.setAttribute('column', '4');
      var yearName = document.createElement('h4');
      var expandYearLink = document.createElement('a');
      expandYearLink.appendChild(document.createTextNode('+ ' + year_entry.year));
      yearName.appendChild(expandYearLink);
      yearHeader.appendChild(yearName);
      year.appendChild(yearHeader);
      const months = document.createElement('div');
      months.setAttribute('container', '');
      months.setAttribute('id', 'month-'+year_entry.year);
      months.setAttribute('hidden', '');
      expandYearLink.addEventListener("click", function(event) {
        event.preventDefault();
        if (months.hasAttribute('hidden')) {
          months.removeAttribute('hidden');
          var text = this.firstChild.nodeValue;
          this.firstChild.nodeValue = "-" + text.substr(1,text.length-1);
        } else {
          months.setAttribute('hidden', '');
          var text = this.firstChild.nodeValue;
          this.firstChild.nodeValue = "+" + text.substr(1,text.length-1);
        }
        this.blur();
      });

      var year_size = 0;
      for (const month_entry of year_entry.months) {
        if (month_entry.size < 1) continue;
        year_size += month_entry.size;

        var month = document.createElement('div');
        month.setAttribute('row', '');
        month.setAttribute('id', 'month'+ month_entry.name);
        var monthSpacer = document.createElement('div');
        monthSpacer.setAttribute('column', '1');
        var monthHeader = document.createElement('div');
        monthHeader.setAttribute('column', '2');
        var monthDownload = document.createElement('div');
        monthDownload.setAttribute('column', '2');
        var monthName = document.createElement('b');
        var expandMonthLink =  document.createElement('a');
        expandMonthLink.appendChild(document.createTextNode('+ ' + month_entry.name));
        monthName.appendChild(expandMonthLink);
        var monthDownloadContent = document.createElement('b');
        monthDownloadContent.appendChild(document.createTextNode(thisClass.convertFileSize(month_entry.size)));
        monthHeader.appendChild(monthName);
        monthDownload.appendChild(monthDownloadContent);
        month.appendChild(monthSpacer);
        month.appendChild(monthHeader);
        month.appendChild(monthDownload);
        const days = document.createElement('div');
        days.setAttribute('container', '');
        days.setAttribute('id', 'days-'+month_entry.name);
        days.setAttribute('hidden', '');
        expandMonthLink.addEventListener("click", function(event) {
          event.preventDefault();
          if (days.hasAttribute('hidden')) {
            days.removeAttribute('hidden');
            var text = this.firstChild.nodeValue;
            this.firstChild.nodeValue = "-" + text.substr(1,text.length-1);
          } else {
            days.setAttribute('hidden', '');
            var text = this.firstChild.nodeValue;
            this.firstChild.nodeValue = "+" + text.substr(1,text.length-1);
          }
          this.blur();
        });
        months.appendChild(month);
        months.appendChild(days);

        for (const day_entry of month_entry.days) {
          var dayname = day_entry.path.substring(day_entry.path.indexOf(year_entry.year)).replace(/\//g, '-');  // ToDo check performance
          var files = document.createElement('div');
          files.setAttribute('container', '');
          files.setAttribute('id', 'files-'+dayname);

          for (const file_entry of day_entry.files) {
            var file = document.createElement('div');
            file.setAttribute('row', '');
            var fileSpacer = document.createElement('div');
            fileSpacer.setAttribute('column', '3');
            var fileName = document.createElement('div');
            fileName.setAttribute('column', '2');
            var fileDownload = document.createElement('div');
            fileDownload.setAttribute('column', '2');
            fileName.appendChild(document.createElement('p'));
            fileName.firstChild.appendChild(document.createTextNode(file_entry.name));
            var fileLink = document.createElement('a');
            fileLink.appendChild(document.createTextNode("\u21E9 " + thisClass.convertFileSize(file_entry.size)));
            fileDownload.appendChild(fileLink);
            fileLink.addEventListener("click", function(event) {
              event.preventDefault();
              var dialog = new ModalSpinnerDialog(i18n.translate('data_logger') + ' - ' + i18n.translate('download_logs'), i18n.translate('download_logs_started'));
              dialog.prepare();
              this.id = 'DownloadLoggerFile';
              IscWebService('getDataLoggerLogfileDownloadName', {'path' : day_entry.path+'/'+file_entry.name}, function(response) {
                if (!response) {
                  DisplayError(response);
                  return;
                }
                if (response.error) {
                  DisplayError(response);
                  return;
                }
                thisClass.downloadLoggerFile(response.data.path, file_entry.name, dialog);
              });
            });
            file.appendChild(fileSpacer);
            file.appendChild(fileName);
            file.appendChild(fileDownload);
            files.appendChild(file);
          }
          days.appendChild(files);
        }
      }

      if (year_size > 0) {
        parent.appendChild(year);
        parent.appendChild(months);
      }
    }
  }

  this.convertFileSize = function(size) {
    if (size < 2) {
      return size + " " + i18n.translate('t_byte');
    } else if (size < 1024) {
      return size + " " + i18n.translate('t_bytes');
    } else if (size < 2048000) {
      return (size/1024).toFixed(1) + " " + i18n.translate('t_kbyte');
    } else {
      return (size/1024/1024).toFixed(1) + " " + i18n.translate('t_mbyte');
    }
  }

  this.downloadLoggerFile = function(filename, targetfilename, dialog) {
    IscWebService('getDownloadLink', {'filename' : filename, 'targetfilename' : targetfilename}, function(response) {
      if (response == undefined) {
        DisplayError(response);
        return;
      }
      if (response.error) {
        DisplayError(response);
        return;
      }
      var link = document.createElement('a');
      var filepath = response.data.URL.split('/');
      var name = filepath[filepath.length -1];
      link.setAttribute("href", response.data.URL);
      link.appendChild(document.createTextNode(i18n.translate('click_here')));
      link.setAttribute("download", name);
      dialog.showDone(i18n.translate('download_logs_finished'));
      dialog.modalBody.appendChild(link);
      link.click();
    });
  }

  this.setDataLoggerArchiveEntries = function(response) {
    if (response && response.data) {
      var newHash = forge.md.md5.create().update(JSON.stringify(response.data)).digest().toHex(); // ToDo check performance
      thisClass.dataLoggerArchiveEntriesUpdated = !(thisClass.dataLoggerArchiveEntriesHash == newHash);
      if (thisClass.dataLoggerArchiveEntriesUpdated) {
        thisClass.dataLoggerArchiveEntriesHash = newHash;
        thisClass.dataLoggerArchiveEntries = response.data;
      }
    } else {
      // no data received
      thisClass.dataLoggerArchiveEntriesUpdated = true;
      thisClass.dataLoggerArchiveEntriesHash = undefined;
      thisClass.dataLoggerArchiveEntries = undefined;
    }
  }

  this.log = function(value) {
    const date = new Date();
    console.log(date.getSeconds() + "." + date.getMilliseconds(), value)
  }

  this.setFocus = function() {
  };

  this.requestData = function() {
    mainSite.timer.getDeviceInfo.oneShot();

    if (!mainSite.timer.getDataLoggerArchiveEntries) {
      mainSite.timer.getDataLoggerArchiveEntries = new TimedRequest(INTERVAL.NONE, 'getDataLoggerArchiveEntries', '', thisClass.setDataLoggerArchiveEntries, thisClass);
    } else {
      mainSite.timer.getDataLoggerArchiveEntries.timeout = INTERVAL.NONE;
    }
    mainSite.timer.getDataLoggerArchiveEntries.addCallbackFunction(thisClass.update);
    mainSite.timer.getDataLoggerArchiveEntries.oneShot();
    mainSite.timer.getDataLoggerArchiveEntries.resetTimeout();
  }

  this.update = function() {
    if (thisClass.visible) {
      //update data in site
      for (var i = 0; i < thisClass.dataBindings.length; i++) {
        thisClass.dataBindings[i]();
      }
    }
  };
}
DataLoggerPage.prototype = new PageTemplate();
DataLoggerPage.prototype.constructor = DataLoggerPage;
/*
 * ##################################################### End DataLoggerPage #####################################################
 */
/*
 * ##################################################### Start HubConfig #####################################################
 */
function HubConfig() {
	
	if (!(this instanceof HubConfig)) {
		return new HubConfig();
	}
	
	PageTemplate.call(this);
	var thisClass = this;
	
	this.prepare = function() {
	if (!thisClass.contentSection) {
		
	/* Get the active hub when the page is loaded */
	IscWebService('getHubUrl', '', function(response) { 
		if(response == undefined || response.error)
		{
			DisplayError(response);
			return;
		}
		document.getElementById("currentHub").innerHTML = response.data.hubUrl; });
	
	thisClass.contentSection = document.createElement('div');
	
	/* Header Text */
	var header = document.createElement('h3');
	header.setAttribute('class', 'h3');
	header.appendChild(document.createTextNode(i18n.translate('hub_header')));
	thisClass.contentSection.appendChild(header);
	/* End Header Text */
	
	/* Current Hub text */
	var currentHub = document.createElement('span');
	currentHub.appendChild(document.createTextNode(i18n.translate('current_hub')));
	currentHub.setAttribute('style', 'font-weight: bold;');
	var currentHubValue = document.createElement('span');
	currentHubValue.appendChild(document.createTextNode(""));
	currentHubValue.setAttribute('id', 'currentHub' );
	currentHub.appendChild(currentHubValue);
	thisClass.contentSection.appendChild(currentHub);
	/* End Current Hub */
	
	thisClass.contentSection.appendChild(document.createElement('br'));
	thisClass.contentSection.appendChild(document.createElement('br'));
	 
	/* Hub selection text */
	var hubText = document.createElement('span');
	hubText.appendChild(document.createTextNode(i18n.translate('hub_select')));
	hubText.setAttribute('style', 'font-weight: bold;');
	thisClass.contentSection.appendChild(hubText);
	/* End selection text Hub*/
	
	thisClass.contentSection.appendChild(document.createElement('br'));
	
	/* Select dropdown tag */
	var selectField = document.createElement('select');
	selectField.setAttribute("style", "width: 30%");
	selectField.addEventListener('change', function() {
	thisClass.sourceChanged(selectField);
	});
	/* End Select dropdown tag */
	
	/*Option for the select tag*/
	var optionGroup = document.createElement('option');
	optionGroup.setAttribute('style', "display: none;");
	optionGroup.appendChild(document.createTextNode("-- " + i18n.translate('hub_select') + " --"));
	selectField.appendChild(optionGroup);
	
	var optionGroup = document.createElement('option');
	optionGroup.value = "testsda.net";
	optionGroup.setAttribute('id','op');
	optionGroup.appendChild(document.createTextNode("testsda.net"));
	selectField.appendChild(optionGroup);
	
	var optionGroup = document.createElement('option');
	optionGroup.value = "securedeviceaccess.net";
	optionGroup.setAttribute('id','op');
	optionGroup.appendChild(document.createTextNode("securedeviceaccess.net"));
	selectField.appendChild(optionGroup);
	/*End options for the select tag*/
	
	thisClass.contentSection.appendChild(selectField);
	
	/* InputField */
	var inputField = document.createElement('input');
	inputField.setAttribute('id', 'inputHub' );
	inputField.setAttribute("style", "width: 30%");
	inputField.setAttribute("type", "text");
	thisClass.contentSection.appendChild(inputField);
	/* End InputField */
	
	/* Change Hub Button */
	var changeButton = document.createElement('button');
	changeButton.setAttribute('class', 'button--xsm');
	changeButton.setAttribute('style', 'margin-left: 1em;');
	changeButton.appendChild(document.createTextNode(i18n.translate('hub_change')));
	/* Button click event */
		changeButton.onclick = ()=> {
		var val = document.getElementById("inputHub");
		if(val == "" || val == undefined || val == null){
			return;
		}
		IscWebService('setHubUrl',  {'hubUrl': val.value }, function(response) {
			if(response == undefined || response.error)
			{
				DisplayError(response);
				return;
			}
			document.getElementById("currentHub").innerHTML = response.data.hubUrl;});
		}
		/* End Button click Event */
	thisClass.contentSection.appendChild(changeButton);
	/* End Change Hub Button */
	
	thisClass.contentSection.appendChild(document.createElement('br'));
	thisClass.contentSection.appendChild(document.createElement('br'));	
	
	/* reset default button */
	var resetDefaultButton = document.createElement('button');
	resetDefaultButton.setAttribute('class','button--xxsm');
	resetDefaultButton.setAttribute('style', 'margin-top: 2em;');
	resetDefaultButton.appendChild(document.createTextNode(i18n.translate('default_hub')));
	resetDefaultButton.onclick = () => {
		document.getElementById("inputHub").value = "";
		IscWebService('setHubUrl',  {'hubUrl': '' }, function(response) {
				if(response == undefined || response.error){
					DisplayError(response);
					return;
				}
				/* perform another Webservice Request because setHubUrl with empty payload does not return the default URL */
				IscWebService('getHubUrl', '', function(response) { 
					if(response == undefined || response.error){
						DisplayError(response);
						return;
					}
					document.getElementById("currentHub").innerHTML = response.data.hubUrl;
				});
			});
			var options = document.querySelectorAll('#op');
			for (var i = 0, l = options.length; i < l; i++) {
				options[i].selected = options[i].defaultSelected;
			}
	}
	thisClass.contentSection.appendChild(resetDefaultButton);
	/* End reset default button */
	
	thisClass.contentSection.appendChild(document.createElement('br'));
	thisClass.contentSection.appendChild(document.createElement('br'));  
	}
	
	mainSite.main.appendChild(thisClass.contentSection);
	}
	/* End prepare function*/
  
	// This function is called if the dropdown source is changed
	this.sourceChanged = function(origin) {
	var src = origin.value;
	document.getElementById("inputHub").value = "wss://hub." + src + "/service";
	selectedHub = "wss://hub." + src + ".net/service";
  }
  // end of source changed function
}
HubConfig.prototype = new PageTemplate();
HubConfig.prototype.constructor = HubConfig;
/*
 * ##################################################### End HubConfig #####################################################
 *//*
 * ##################################################### Start StatusPage Addon #####################################################
 */
StatusPage.prototype.portalConnectionState = undefined;
StatusPage.prototype.appendDOMFragmentSda_portalConnectionState = function(parentElement) {
  var elem = document.createElement('b');
  elem.appendChild(document.createTextNode(i18n.translate('sda_portal_connection') + ': '));
  parentElement.appendChild(elem);
  parentElement.appendChild(document.createElement('br'));
  var textNode = document.createTextNode(i18n.translate('n/a'));
  parentElement.appendChild(textNode);
  parentElement.appendChild(document.createElement('br'));

  var thisClass = this;
  thisClass.dataBindings.push(
    function() {
      if (thisClass.portalConnectionState == undefined) {
        return;
      }
      textNode.nodeValue = thisClass.portalConnectionState.ConnectionStatus[1] + ' (' + thisClass.portalConnectionState.ConnectionStatus[0] + ')';
      if (thisClass.portalConnectionState.ConnectionStatus[0] != 0) {
        textNode.nodeValue += ' - ' + i18n.translate('last_connect_error') + ': ' + thisClass.portalConnectionState.ConnectionError[1] + ' (' + thisClass.portalConnectionState.ConnectionError[0] + ')';
      }
    }
  );

  if (!mainSite.timer.getPortalConnectionState) {
    mainSite.timer.getPortalConnectionState = new TimedRequest(INTERVAL.MINUTE, 'getPortalConnectionState', '', function(response) {
      if (response == undefined) {
        //TODO: $('#message').text(i18n.translate('something_wrong') + ' ' + i18n.translate('device_unavailable'));
      } else if (response.error) {
        //TODO: $('#message').text(i18n.translate('error_message') + ': ' + response.error);
      } else {
        thisClass.portalConnectionState = response.data;
      }
    }, thisClass);
    mainSite.timer.getPortalConnectionState.addCallbackFunction(thisClass.update);
  }
  mainSite.timer.getPortalConnectionState.oneShot();
  mainSite.timer.getPortalConnectionState.resetTimeout();
}

StatusPage.prototype.buildInfo = undefined;
StatusPage.prototype.appendDOMFragmentSda_buildinfoTo = function(parentElement) {
  var elem = document.createElement('b');
  elem.appendChild(document.createTextNode(i18n.translate('sda_software') + ':'));
  parentElement.appendChild(elem);

  parentElement.appendChild(document.createElement('br'));
  var textNode = document.createTextNode(i18n.translate('n/a'));
  parentElement.appendChild(textNode);
  parentElement.appendChild(document.createElement('br'));

  var thisClass = this;
  thisClass.dataBindings.push(
    function() {
      if (thisClass.buildInfo == undefined) {
        return;
      }
      textNode.nodeValue = thisClass.buildInfo.buildInfo;
    }
  );

  if (!mainSite.timer.getBuildInfo) {
    mainSite.timer.getBuildInfo = new TimedRequest(INTERVAL.MINUTE, 'getBuildInfo', '', function(response) {
      if (response == undefined) {
        //TODO: $('#message').text(i18n.translate('something_wrong') + ' ' + i18n.translate('device_unavailable'));
      } else if (response.error) {
        //TODO: $('#message').text(i18n.translate('error_message') + ': ' + response.error);
      } else {
        thisClass.buildInfo = response.data;
      }
    }, thisClass);
    mainSite.timer.getBuildInfo.addCallbackFunction(thisClass.update);
  }
  mainSite.timer.getBuildInfo.oneShot();
  mainSite.timer.getBuildInfo.resetTimeout();
}

StatusPage.prototype.connectorID = undefined;
StatusPage.prototype.appendDOMFragmentServiceIdTo = function(parentElement) {
  var elem = document.createElement('b');
  elem.appendChild(document.createTextNode(i18n.translate('service_id') + ':'));
  parentElement.appendChild(elem)
  parentElement.appendChild(document.createElement('br'));
  var textNode = document.createTextNode(i18n.translate('n/a'));
  parentElement.appendChild(textNode);
  parentElement.appendChild(document.createElement('br'));

  var thisClass = this;
  thisClass.dataBindings.push(
    function() {
      if (thisClass.connectorID == undefined) {
        return;
      }
      textNode.nodeValue = thisClass.connectorID.connectorid;
    }
  );

  if (!mainSite.timer.getConnectorID) {
    mainSite.timer.getConnectorID = new TimedRequest(INTERVAL.MINUTE, 'getConnectorID', '', function(response) {
      if (response == undefined) {
        //TODO: $('#message').text(i18n.translate('something_wrong') + ' ' + i18n.translate('device_unavailable'));
      } else if (response.error) {
        //TODO: $('#message').text(i18n.translate('error_message') + ': ' + response.error);
      } else {
        thisClass.connectorID = response.data;
      }
    }, thisClass);
    mainSite.timer.getConnectorID.addCallbackFunction(thisClass.update);
  }
  mainSite.timer.getConnectorID.oneShot();
  mainSite.timer.getConnectorID.resetTimeout();
}

StatusPage.prototype.appendDOMFragmentCOInfosTo = function(parentElement) {
  var span = document.createElement('span');
  span.setAttribute('hidden', '');
  var thisClass = this;
  thisClass.dataBindings.push(
    function() {
      if (mainSite.deviceInfo && mainSite.deviceInfo.EtsDownload) {
        span.removeAttribute('hidden');
      } else {
        span.setAttribute('hidden', '');
      }
    }
  );
  parentElement.appendChild(span);
  parentElement = span;
  var elem = document.createElement('b');
  elem.appendChild(document.createTextNode(i18n.translate('grant_access_states') + ':'));
  parentElement.appendChild(elem)

  parentElement.appendChild(document.createElement('br'));
  var grantRemoteAccessCO = 2;
  this.appendDOMFragmentKimCoInfoTo(parentElement, grantRemoteAccessCO);

  parentElement.appendChild(document.createElement('br'));
  var grantResidentsRemoteAccessCO = 4;
  this.appendDOMFragmentKimCoInfoTo(parentElement, grantResidentsRemoteAccessCO);

  parentElement.appendChild(document.createElement('br'));
  var grantInstallersRemoteAccessCO = 6;
  this.appendDOMFragmentKimCoInfoTo(parentElement, grantInstallersRemoteAccessCO);

  if (StatusPage.prototype.disableQuickConnect && StatusPage.prototype.disableQuickConnect === true) {
  } else {
    parentElement.appendChild(document.createElement('br'));
    var grantQuickAccessRemoteAccessCO = 8;
    this.appendDOMFragmentKimCoInfoTo(parentElement, grantQuickAccessRemoteAccessCO);
  }

  parentElement.appendChild(document.createElement('br'));
  var grantVPNRemoteAccessCO = 10;
  this.appendDOMFragmentKimCoInfoTo(parentElement, grantVPNRemoteAccessCO);

  parentElement.appendChild(document.createElement('br'));
  parentElement.appendChild(document.createElement('br'));

  elem = document.createElement('b');
  elem.appendChild(document.createTextNode(i18n.translate('connection_states') + ':'));
  parentElement.appendChild(elem)

  parentElement.appendChild(document.createElement('br'));

  var statePortalConnectionCO = 20;
  this.appendDOMFragmentKimCoInfoTo(parentElement, statePortalConnectionCO);

  parentElement.appendChild(document.createElement('br'));

  var stateAnyRemoteConnectionCO = 21;
  this.appendDOMFragmentKimCoInfoTo(parentElement, stateAnyRemoteConnectionCO);

  parentElement.appendChild(document.createElement('br'));

  var stateResidentsRemoteConnectionCO = 22;
  this.appendDOMFragmentKimCoInfoTo(parentElement, stateResidentsRemoteConnectionCO);

  parentElement.appendChild(document.createElement('br'));
  var stateInstallersRemoteConnectionCO = 23;
  this.appendDOMFragmentKimCoInfoTo(parentElement, stateInstallersRemoteConnectionCO);

  if (StatusPage.prototype.disableQuickConnect && StatusPage.prototype.disableQuickConnect === true) {
  } else {
    parentElement.appendChild(document.createElement('br'));
    var stateQuickConnectRemoteConnectionCO = 24;
    this.appendDOMFragmentKimCoInfoTo(parentElement, stateQuickConnectRemoteConnectionCO);
  }

  parentElement.appendChild(document.createElement('br'));
  var stateVPNRemoteConnectionCO = 25;
  this.appendDOMFragmentKimCoInfoTo(parentElement, stateVPNRemoteConnectionCO);

  parentElement.appendChild(document.createElement('br'));
  parentElement.appendChild(document.createElement('br'));

  elem = document.createElement('b');
  elem.appendChild(document.createTextNode(i18n.translate('general_information') + ':'));
  parentElement.appendChild(elem)

  parentElement.appendChild(document.createElement('br'));

  var errorIndicationCO = 30;
  this.appendDOMFragmentKimCoInfoTo(parentElement, errorIndicationCO);

  parentElement.appendChild(document.createElement('br'));
  var portalConnectionInfoCO = 31;
  this.appendDOMFragmentKimCoInfoTo(parentElement, portalConnectionInfoCO);

  parentElement.appendChild(document.createElement('br'));
  var connectionErrorInfoCO = 32;
  this.appendDOMFragmentKimCoInfoTo(parentElement, connectionErrorInfoCO);

  parentElement.appendChild(document.createElement('br'));
  var thisClass = this;

}

StatusPage.prototype.prepareAppInfo = function(divAppInfomation) {
  headerAppInformation = document.createElement('h3');
  headerAppInformation.setAttribute('class', 'h3');
  headerAppInformation.appendChild(document.createTextNode(i18n.translate('sda_application_information')));
  divAppInfomation.appendChild(headerAppInformation);

  var fragmentAppState = document.createElement('span');
  fragmentAppState.setAttribute('hidden', '');
  divAppInfomation.appendChild(fragmentAppState);
  this.appendDOMFragmentAppStateTo(fragmentAppState);

  var thisClass = this;
  thisClass.dataBindings.push(
    function() {
      if (mainSite.deviceInfo && mainSite.deviceInfo.EtsDownload) {
        fragmentAppState.removeAttribute('hidden');
      } else {
        fragmentAppState.setAttribute('hidden', '');
      }
    }
  );

  this.appendDOMFragmentSda_portalConnectionState(divAppInfomation);

  divAppInfomation.appendChild(document.createElement('br'));

  this.appendDOMFragmentSda_buildinfoTo(divAppInfomation);

  divAppInfomation.appendChild(document.createElement('br'));

  this.appendDOMFragmentServiceIdTo(divAppInfomation);

  divAppInfomation.appendChild(document.createElement('br'));

  this.appendDOMFragmentCOInfosTo(divAppInfomation);

  divAppInfomation.appendChild(document.createElement('br'));
}

StatusPage.prototype.updateCO = function(span, textNode, currentCO) {
  switch (currentCO.id) {
    case 31:
      textNode.nodeValue = i18n.translate(currentCO.value);
      if (currentCO.value == 'Connected' || currentCO.value == 'True') {
        span.setAttribute('class', 'text--success');
      } else if (currentCO.value) {
        span.setAttribute('class', 'text--error');
      }
      break;
    case 32:
      textNode.nodeValue = i18n.translate(currentCO.value);
      if (currentCO.value == 'None' || currentCO.value == 'False') {
        span.setAttribute('class', 'text--success');
      } else if (currentCO.value) {
        span.setAttribute('class', 'text--error');
      }
      break;
    default:
      if (currentCO.value == '1') {
        span.setAttribute('class', 'text--success');
        textNode.nodeValue = i18n.translate('True');
      } else if (currentCO.value == '0') {
        span.setAttribute('class', 'text--error');
        textNode.nodeValue = i18n.translate('False');
      }
      break;
  }
}
/*
 * ##################################################### End StatusPage Addon #####################################################
 */
