/*
 * ##################################################### Start Product Addon #####################################################
 */

// Add product specific setting here. Product specific settings are superior to manufacturer settings.
 
MainSite.prototype.configureProductSettings = function() {
  this.kimFriendlyName = 'ise KNX Remote Access';
} 

NetworkSettingsPage.prototype.configureProductSettings = function() {
  this.allowDisableNtp = false;
}

/*
 * ##################################################### End Product Addon #####################################################
 */

 /*
 * ##################################################### Start MainSite Addon #####################################################
 */

MainSite.prototype.addProductTopNavMenuItems = function() {
  this.pages['LoginPage'] = new LoginPage();

  this.menu.system.target.insertAsFirst(new MenuItem('change_settings', 'NetworkSettingsPage'));
  this.pages['NetworkSettingsPage'] = new NetworkSettingsPage();
  this.pages['NetworkSettingsPage'].ipSettingsFormEnabled = true;
  this.pages['NetworkSettingsPage'].ntpSettingsFormEnabled = true;

  this.menu.add(new MenuItem('user', new Menu(new MenuItem('change_password', 'ChangePasswordPage'))));
  this.pages['ChangePasswordPage'] = new ChangePasswordPage();

  this.menu.user.target.add(new MenuItem('logout', 'LogoutPage'));
  this.pages['LogoutPage'] = new LogoutPage();

  this.menu.insertAfter(new MenuItem('data_logger', 'DataLoggerPage'), this.menu.device_status);
  this.pages['DataLoggerPage'] = new DataLoggerPage();
  
  this.pages['HubConfig'] = new HubConfig();
}

/*
 * ##################################################### End MainSite Addon #####################################################
 */
